
#include "predef.h"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <constants.h>
#include <basictypes.h>
#include <buffers.h>
#include <htmlfiles.h>
#include <http.h>
#include <utils.h>
#include <iosys.h>
#include <system.h>
#include <multipartpost.h>
#include <Script.h>

extern OS_CRIT cs; // The critical section identifer
char scriptCode[65000];

extern Script script;

int ExtractScript( int sock, char *url, char *pData, char *rxBuffer )
{
   char tmp[256];
   BOOL bBinary = FALSE;
   SendHTMLHeader( sock );
   writestring( sock, "<HTML><BODY>" );

   int fd = ExtractPostData( "code", pData, scriptCode, 64999 );
   if ( fd > 0 )
   {
		//Register global variables that script functions can modify

		//Load and compile the script from a file.
	   	OSCritEnter( &cs, 0 );
		script.ConfigureEngine(scriptCode);
		OSCritLeave( &cs );

      writestring( sock, "Start of File <BR>" );
      writestring( sock, scriptCode);


      writestring( sock, "<BR>End of File\r\n" );
   }
   else
   {
      writestring( sock, "Unable to extract file <BR>\r\n" );
   }

   writestring( sock, "</BODY></HTML>" );

   return 0;
}



int MyDoPost( int sock, char *url, char *pData, char *rxBuffer )
{
   iprintf( "Processing post for %s\r\n", url );
   if ( httpstricmp( url, "FILEPOST" ) == 0 )
   {
      return ExtractScript( sock, url, pData, rxBuffer );
   }

   return 0;
}


void RegisterPost()
{
   SetNewPostHandler( MyDoPost );
}

